<?php

class CNInFolderObject extends CNObject {
 var $folderpath = null;

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 global $FEATURE, $NODE_ID;
 if (! in_array($objecttype, $this->getParentTType())) {
 return null;
 }

 $channelId = 0;
 if ($FEATURE["multichannelling"]) {
 
 $folder = new CNFolderObject($objectid);
 $objectid = $folder->getMasterId();

 
 $nodeInfo = get_nodeinfo($NODE_ID);
 if ($nodeInfo["master_id"]) {
 $channelId = $NODE_ID;
 }
 }

 $folders = array();
 if ($searchterm && $recursive) {
 mini_walk(&$folders, $objectid);
 }
 $folders[] = $objectid;
 $sql = "SELECT " . sqlf_table($this->_getNodeTable()) . ".*, ".sqlf_tl_num($objecttype)." as parentobjecttype, ".sqlf_tl_num($objectid)." as parentobjectid FROM " .
 $this->_getSearchTable() . " WHERE " . sqlf_table($this->_getNodeTable()) . ".channel_id = ".sqlf_tl_num($channelId)." AND " . sqlf_field($this->_getFolderColumn()) . " IN(".implode(",",sqlf_tl_num_array($folders)).")";
 $baseFilter = $this->_getBaseFilter();
 $searchFilter = $this->_getSearchFilter($searchterm);
 if ($baseFilter) {
 $sql .= " AND " . $baseFilter;
 }
 if ($searchFilter) {
 $sql .= " AND " . $searchFilter;
 }
 $sql .= " GROUP BY " . sqlf_table($this->_getNodeTable()) . ".id";
 $rs = query($sql);
 return $this->_processResultSet($rs);
 }

 function getFolderPaths(&$objects, $maxentries = 6) {
 if (!is_array($objects)) {
 return;
 }

 $ids = array();
 foreach ($objects as $o) {
 $ids[] = $o->getId();
 }

 $pathinfo = get_folder_structure($this->getTType(), $ids, $maxentries);
 foreach ($objects as $o) {
 $o->folderpath = $pathinfo[$o->getId()];
 }
 }

 function _getSearchTable() {
 return sqlf_table($this->_getNodeTable());
 }

 function _getFolderColumn() {
 return "folder_id";
 }

 function getParentTType() {
 return array(T_FOLDER, T_FOLDER_CHANNEL, T_DOMAIN, T_DOMAIN_CHANNEL);
 }

 




 function getFolderPath($maxentries = 6) {
 if (!$this->folderpath) {
 $pathinfo = get_folder_structure($this->getTType(), array($this->getID()), $maxentries);
 $this->folderpath = $pathinfo[$this->getID()];
 }
 return $this->folderpath;
 }

 




 function getMasterId() {
 global $FEATURE;

 if ($FEATURE["multichannelling"]) {
 
 $channelset_id = $this->getFieldValue("channelset_id");
 $channel_id = $this->getFieldValue("channel_id");
 $isMaster = $this->getFieldValue("is_master");
 if ($isMaster || !$channelset_id || !$channel_id) {
 
 return $this->getID();
 } else {
 
 $sql = "SELECT id FROM ".sqlf_table($this->_getNodeTable())." WHERE channelset_id = ".sql_num($channelset_id)." AND is_master = 1";
 $rs = query($sql);
 if ($rs["num"] == 0) {
 
 halt();
 } else {
 return $rs["arr"][0]["id"];
 }
 }
 } else {
 return $this->getID();
 }
 }

 





 function getLocalizedId($nodeId) {
 global $FEATURE;

 if ($FEATURE["multichannelling"]) {
 
 $channelset_id = $this->getFieldValue("channelset_id");
 $channel_id = $this->getFieldValue("channel_id");
 if (!$channelset_id) {
 
 return $this->getID();
 } else if ($channel_id == $nodeId) {
 
 return $this->getID();
 } else {
 
 $inheritanceMap = getInheritanceMap($nodeId);

 
 
 
 if (!isset($inheritanceMap[$channel_id])) {
 return $this->getID();
 }

 
 $rs = query("SELECT id, channel_id FROM ".sqlf_table($this->_getNodeTable())." WHERE channelset_id = ".sql_num($channelset_id));
 $cand = null;
 $candOrder = null;

 foreach ($rs["arr"] as $row) {
 $channelOrder = $inheritanceMap[$row["channel_id"]];

 
 
 if ($channelOrder !== null && (!$candOrder || $channelOrder > $candOrder)) {
 $cand = $row["id"];
 $candOrder = $channelOrder;
 }
 }

 
 return $cand;
 }
 } else {
 return $this->getID();
 }
 }

 









 function _searchInObjectREST($method, $attribute, $objecttype, $objectid, &$km, $searchterm, $recursive) {
 global $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN, $NODE_ID;
 if (!in_array($objecttype, $this->getParentTType())) {
 return null;
 }

 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/$method/$objectid?sid=$SESSION_TOKEN&nodeId=$NODE_ID&sortby=name&sortorder=ASC&reduce=true";

 
 if ($searchterm) {
 $url .= "&search=".urlencode($searchterm);
 
 if ($recursive) {
 $url .= "&recursive=true";
 }
 }

 
 $url .= "&inherited=false";

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode().' for url '.$url);
 }

 $objects = json_decode($json,true);
 $objects = $objects[$attribute];
 $objects = $km->remap($objects);
 foreach ( $objects as &$obj ) {
 $obj["parentobjectid"] = $obj["folder_id"] ? $obj["folder_id"] : $obj["mother"];
 $obj["parentobjecttype"] = T_FOLDER;
 }
 return $this->_processResultset(array("arr" => $objects));
 }
}
