<?
function lock($id,$type) {

 global $TIME, $USER_ID, $LOCK_TIME, $FOLDER_ID, $T_PAGE, $T_PAGECONTENT, $T_TEMPLATE, $W_EDIT, $T_FOLDER, $FEATURE;

 if ( ($type != "page" && $type != "template") || !is_numeric($id) ) 
 halt(7,"lock: invalid id($id) or type($type)");

 if ($type == "page") {
 $_id = $id;
 $t_type = $T_PAGECONTENT;
 $page = get_pageinfo($id);
 $id = $page["cid"];
 $type = "content";
 if ( !is_numeric($id) ) {
 halt(7, "lock: invalid content-id for page-id($_id)");
 }

 
 if(!perm($USER_ID, $T_FOLDER, $page["folder_id"], 13, $page['contentgroup_id'], $T_PAGE, 12) ) {
 return false;
 }
 }

 if ($type == "template") {
 $t_type = $T_TEMPLATE;
 }

 $fetch_lock_status_sql = "SELECT locked, locked_by FROM ".sqlf_table($type)." WHERE id = ".sql_num($id);
 $status_rs = query($fetch_lock_status_sql);

 
 
 
 
 $sql = "UPDATE " . sqlf_table($type)
 . " SET locked = " . sql_num($TIME)
 . ", locked_by = " . sql_num($USER_ID)
 . " WHERE id = " . sql_num($id)
 . "   AND (   locked_by = " . sql_num($USER_ID)
 . "        OR locked = 0"
 . "        OR " . sql_num($TIME) . " - locked > " . sql_num($LOCK_TIME)
 . "       )";
 $rs = query($sql);

 
 if ($FEATURE["javaparser"] && $rs["num"] > 0) {
 node_class("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($t_type, $id);
 }

 
 
 
 
 $acquired_rs = query($fetch_lock_status_sql);
 if ($acquired_rs["arr"][0]["locked_by"] != $USER_ID) {
 return false;
 }

 
 if ($status_rs["arr"][0]["locked_by"] != $USER_ID) {
 $f_id = ($FOLDER_ID ? $FOLDER_ID : 0);
 logcmd($W_EDIT, $t_type, $id, $f_id, "lock");
 }

 return true;
}





function unlock($id,$type) {

 global $USER_ID, $TIME, $FEATURE, $T_PAGE, $T_PAGECONTENT, $T_TEMPLATE, $T_OBJTAG, $W_EDIT;

 if (($type != "page" && $type != "template") || !$id) halt(7,"lock: invalid id($id) or type($type)");
 $obj_type = $type == 'page' ? $T_PAGE : $T_TEMPLATE;

 if ($type == "page") {
 $page = get_pageinfo($id);
 $id = $page["cid"];
 $type = "content";
 $t_type = $T_PAGECONTENT;
 } else if ($type == "template") {
 $t_type = $T_TEMPLATE;
 }
 

 if ($FEATURE["contentversion2"] && $type == "content") {
 node_class("cnpageobject");
 $pageobject = new CNPageObject($page["id"]);
 $pageobject->createVersion($TIME,$page["editor"]);
 }

 $sql = "UPDATE ".sqlf_table($type)." SET locked = 0, locked_by = 0 WHERE id = ".sqlf_tl_num($id)." AND locked_by = ".sqlf_tl_num($USER_ID);
 $rs = query($sql);
 
 if ($FEATURE["javaparser"] && $rs["num"] > 0) {
 node_class("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($t_type, $id);
 }
}

function is_locked($id,$type,$lockedby = false) {

 global $USER_ID, $TIME, $LOCK_TIME;

 if (($type != "page" && $type != "template") || !$id) halt(7,"lock: invalid id($id) or type($type)");

 if ($type == "page") {
 $page = get_pageinfo($id);
 $id = $page["cid"];
 $type = "content";
 }


 $sql = "SELECT locked, locked_by FROM ".sqlf_table($type)." WHERE id = '".sqlf_escaped($id)."'";
 $rs = query($sql);
 $locked = $rs["arr"][0]["locked"];

 if ($lockedby) {
 if ($locked == 0 || ($TIME - $locked) > $LOCK_TIME) return false;
 else return $rs["arr"][0]["locked_by"];
 }

 if ($locked == 0 || ($TIME - $locked) > $LOCK_TIME || $rs["arr"][0]["locked_by"] == $USER_ID) return false;
 else return true;

}

function is_locked_by($id,$type) {
 return is_locked($id,$type,true);
}

function lock_table($table) {
 global $TABLE_LOCK, $SETTINGS;
 
 if ($SETTINGS["dbtype"] != "mysql") return;
 
 $TABLE_LOCK = true;
 $sql = "LOCK TABLES ".sqlf_table($table)." WRITE";
 query($sql);

}

function unlock_table($table) {
 global $TABLE_LOCK, $SETTINGS;

 if ($SETTINGS["dbtype"] != "mysql") return;
 
 $sql = "UNLOCK TABLES";
 query($sql);
 $TABLE_LOCK = false;

}
?>
